# GraphQL Requests

#### GraphQL Requests

When testing a GraphQL endpoint, we set the `$schema` property on the test class.

```php
/**
 * @var string the GraphQL schema name
 */
protected $schema = 'sandboxes';
```

The mutation must be stored in a variable for readability in each test.

```php
public function sandboxes_save_object_returns_200(): void
{
    $mutation = <<<'GQL'
    mutation {
        saveSandbox(data: { title: "New Sandbox" }) {
            id
            title
        }
    }
    GQL;
    
    // ...
}
```

To run the GraphQL endpoint, call the `->graphql()` method.

```php
public function sandboxes_save_object_returns_200(): void
{
    $mutation = <<<'GQL'
    mutation {
        saveSandbox(data: { title: "New Sandbox" }) {
            id
            title
        }
    }
    GQL;

    $this->actingAsAdmin()
        ->authenticate()
      	->graphql($mutation);
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.elentra.org/api/automated-testing/functional-tests/testing-http-verbs/graphql-requests.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
